<template>
  <div>
    <div class="dashboard-page-container pb-5">
      <h1 class="page-title">
        You are required to enter security questions for you to reset your
        Transaction Pin
      </h1>
      <div class="mt-4">
        <form @submit.prevent="submitForm">
          <div class="row g-2">
            <div class="col-sm-12 col-md-6">
              <div class="card card-setting" style="min-height: 433px">
                <div class="pt-2 pb-5 px-2">
                  <p class="fw-bold mb-0">Select security question</p>
                  <select
                    id="formSecurity"
                    v-model="securityQuestion"
                    name="formSelect"
                    class="form-select mb-5 w-50"
                  >
                    <option
                      v-for="(question, i) in questions"
                      :key="i"
                      :value="question"
                    >
                      {{ `Question ${i + 1}` }}
                    </option>
                  </select>
                  <div class="mb-5">
                    <p class="my-0 fw-bold">
                      {{ securityQuestion.question }} ?
                    </p>

                    <div class="pin-input-container mt-3">
                      <p class="text-muted fw-bold">Answer</p>
                      <input
                        id="formAnwser"
                        v-model="securityQuestionAns"
                        v-validate="'required'"
                        class="ans-input"
                        placeholder="Answer"
                        :name="`${securityQuestion.question} Answer`"
                      />
                    </div>
                    <div
                      v-show="
                        verrors.has(`${securityQuestion.question} Answer`)
                      "
                      class="invalid-feedback d-block"
                    >
                      {{ verrors.first(`${securityQuestion.question} Answer`) }}
                    </div>
                  </div>
                  <div class="mt-3">
                    <!-- <vs-button
                      type="submit"
                      :loading="form.active"
                      primary
                      class="px-4 py-1"
                    >
                      Save
                    </vs-button> -->
                  </div>
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-6">
              <div class="card card-setting">
                <form @submit.prevent="submitForm">
                  <div class="py-5 px-2">
                    <p class="fw-bold">Set Transaction PIN</p>
                    <!-- <p>
                Change your current ATM Card PIN to a <br />
                new PIN by starting with the old PIN
              </p> -->
                    <div class="pin-input-container mt-3">
                      <p class="text-muted fw-bold">New Pin</p>
                      <!-- <PincodeInput
                        v-model="form.code"
                        placeholder="0"
                        :secure="true"
                        :preview-duration="0"
                        :character-preview="false"
                      /> -->

                      <input
                        id="formPinOne"
                        v-model="form.code"
                        v-validate="'required|min:4'"
                        class="ans-input"
                        placeholder="Answer"
                        name="Pin"
                        :type="showPin ? 'password' : 'text'"
                      />

                      <vs-button
                        circle
                        icon
                        primary
                        class="px-3 me-auto"
                        size="mini"
                        flat
                        type="button"
                        @click="showPin = !showPin"
                      >
                        {{ showPin ? 'Show Pin' : 'Hide Pin' }}
                      </vs-button>

                      <div
                        v-show="verrors.has('Pin')"
                        class="invalid-feedback d-block"
                        style="display: block"
                      >
                        {{ verrors.first('Pin') }}
                      </div>
                    </div>
                    <div class="pin-input-container mt-3">
                      <p class="text-muted fw-bold">Confirm New Pin</p>
                      <!-- <PincodeInput
                        v-model="form.pinConfirm"
                        placeholder="0"
                        :secure="true"
                        :preview-duration="0"
                        :character-preview="false"
                      /> -->

                      <input
                        id="formPinTwo"
                        v-model="form.pinConfirm"
                        v-validate="'required|min:4'"
                        class="ans-input"
                        placeholder="Answer"
                        name="Confirm Pin"
                        :type="showPin ? 'password' : 'text'"
                      />

                      <div
                        v-show="verrors.has('Confirm Pin')"
                        class="invalid-feedback d-block"
                      >
                        {{ verrors.first('Confirm Pin') }}
                      </div>
                    </div>
                    <div class="mt-3">
                      <!-- <button class="btn btn-primary btn-lg h6 float-end px-4">
                    Save
                  </button> -->

                      <vs-button
                        type="submit"
                        :loading="form.active"
                        primary
                        class="px-4 py-1"
                      >
                        Save
                      </vs-button>
                    </div>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
// import TransferBetweenAccounts from '@/assets/icons/transfer-between-accounts.svg?inline'
// import TransferToCorebankAccount from '@/assets/icons/transfer-to-corebank-account.svg?inline'
// import TransferToOtherBanks from '@/assets/icons/transfer-to-other-banks.svg?inline'
// import PincodeInput from 'vue-pincode-input'

export default {
  // components: { PincodeInput },
  layout: 'dashboard',
  asyncData({ $axios }) {
    // /miscellaneous/security-questions
    // const questionsData = await $axios.$get('/miscellaneous/security-questions')
    // console.log(questionsData)
    return {}
  },
  data: () => ({
    form: {
      code: '',
      newCode: '',
      pinConfirm: '',
      active: false,
    },
    showPin: true,
    securityQuestion: {
      question: 'What is your Favorite Food',
      ans: '',
    },
    securityQuestionAns: '',
    questions: [
      {
        question: 'What is your Favorite Food',
        ans: '',
      },
      {
        question: 'What is your Favorite Color',
        ans: '',
      },
    ],
  }),
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (!this.form.code || !this.form.pinConfirm) {
            this.openNotification(
              'top-left',
              'warning',
              'All Fields are required '
            )
            return
          }

          if (
            this.form.code !== this.form.pinConfirm ||
            this.form.pinConfirm.length !== 4 ||
            this.form.code.length !== 4
          ) {
            this.openNotification('top-left', 'warning', 'Pins donts match')
            return
          }
          // console.log(this.form)
          const data = {
            newTransactionPin: this.form.code,
            securityAnswer: this.securityQuestionAns,
          }
          this.form.active = true

          this.$axios
            .$patch('/transaction/reset/pin', data)
            .then(() => {
              // console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              // const modal = new bootstrap.Modal(
              //   document.getElementById('PaymentSuccessModal'),
              //   {}
              // )
              // modal.show()
              this.openNotification(
                'top-left',
                'success',
                'Transaction PIN Reset successfully'
              )
            })
            .catch((error) => {
              // console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.ans-input {
  max-width: 250px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
  border: none;
  padding: 10px;
}
.vue-pincode-input {
  max-width: 45px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
}
</style>
